//============================================================
//By Dmitry Kolomiets aka B4rr4cuda
//B4rr4cuda@rambler.ru
//============================================================

unit HotKeyM;

interface
uses
  Windows, Messages, SysUtils, Classes,{TCWND,}VirtualKeys{,unit1,konwork};

type THKeyType=class
           Modifiers:SmallInt;
           Key:Word;
           Action:string;
           id:THandle;
           SendOrNot:byte;
           BothConTC:byte;
           constructor Create;
           end;

var     HotKeyList:TStringList;                       // 

        PathToWdx:string;

procedure SetPathToWdx(Path:String);
procedure SaveHotKeys;   //   
procedure LoadHotKeys(Hwnd:THandle);    //   
procedure RegHotKeys(Hwnd:THandle);   // 
procedure UnRegHotKeys(Hwnd:THandle);   // 

function ModToStr(X:Byte):string;          //   (8  Winkey)
function StrToMod(ModS:String):Byte;          //C   (Winkey  8)
function StrToModAlt(ModS:String):Byte;

procedure AddHot(Hot:string; Act:string; BCTC:Byte; SysHot:Boolean); //   
procedure GetHotPrm(str:string;var Listo:TStringList); //   
procedure GetWhrAndPrv(str:string;var WhereToWork,PreventSending:byte); //

function GetLastKeyOfHotKey(HotKeyStr:string):string;//    


implementation

uses KeysCommands;
//   
///-----------------------------------------------------------------
procedure AddHot(Hot:string; Act:string; BCTC:Byte;SysHot:Boolean);
var s:string;
begin
  HotKeyList.AddObject(inttostr(HotKeyList.count),TObject(THKeyType.Create));
  THKeyType(HotKeyList.Objects[HotKeyList.count-1]).Create;
  THKeyType(HotKeyList.Objects[HotKeyList.count-1]).Modifiers:=StrToMod(Hot);

  s:=Hot;
  while Pos('+',s)>0 do
  Delete(s,1,Pos('+',s));

  THKeyType(HotKeyList.Objects[HotKeyList.count-1]).Key:=StringToVirtualKeyCode(s);
  THKeyType(HotKeyList.Objects[HotKeyList.count-1]).Action:=Act;

  THKeyType(HotKeyList.Objects[HotKeyList.count-1]).SendOrNot:=Byte(SysHot);
  THKeyType(HotKeyList.Objects[HotKeyList.count-1]).BothConTC:=BCTC;

end;
///-----------------------------------------------------------------




///-----------------------------------------------------------------
procedure SetPathToWdx(Path:String);
begin
PathToWdx:=Path;
end;
///-----------------------------------------------------------------

//    
///-----------------------------------------------------------------
function GetLastKeyOfHotKey(HotKeyStr:string):string;
var s:string;
begin
  s:=HotKeyStr;
   while Pos('+',s)>0 do
  Delete(s,1,Pos('+',s));
  result:=s;
end;
///-----------------------------------------------------------------

// 
///-----------------------------------------------------------------
constructor THKeyType.Create;
begin
  inherited Create;
end;
///-----------------------------------------------------------------


//C   (Winkey  8)
///-----------------------------------------------------------------
function StrToMod(ModS:String):Byte;
var x:Byte; s:string;
begin
  {MOD_ALT = 1;
  MOD_CONTROL = 2;
  MOD_SHIFT = 4;
  MOD_WIN = 8;}

  s:=ModS;
  x:=0;

  if Pos('Win+',s)>0 then
   begin
    x:=x+8;
    Delete(s,Pos('Win+',s),Length('Win+'));
   end;
   
  if Pos('Ctrl+',s)>0 then
   begin
    x:=x+2;
    Delete(s,Pos('Ctrl+',s),Length('Ctrl+'));
   end;

  if Pos('Alt+',s)>0 then
   begin
    x:=x+1;
    Delete(s,Pos('Alt+',s),Length('Alt+'));
   end;


  if Pos('Shift+',s)>0 then
   begin
    x:=x+4;
    Delete(s,Pos('Shift+',s),Length('Shift+'));
   end;

  result:=x;
end;
///-----------------------------------------------------------------

//C   (Winkey  8)
///-----------------------------------------------------------------
function StrToModAlt(ModS:String):Byte;
var x:Byte; s:string;
begin
  {MOD_ALT = 1;
  MOD_CONTROL = 2;
  MOD_SHIFT = 4;
  MOD_WIN = 8;}

  s:=ModS;
  x:=0;
 
  if Pos('Win',s)>0 then
   begin
    x:=x+8;
    Delete(s,Pos('Win+',s),Length('Win'));
   end;
   
  if Pos('Ctrl',s)>0 then
   begin
    x:=x+2;
    Delete(s,Pos('Ctrl',s),Length('Ctrl'));
   end;

  if Pos('Alt',s)>0 then
   begin
    x:=x+1;
    Delete(s,Pos('Alt',s),Length('Alt'));
   end;


  if Pos('Shift',s)>0 then
   begin
    x:=x+4;
    Delete(s,Pos('Shift',s),Length('Shift'));
   end;

  result:=x;
end;
///-----------------------------------------------------------------

//   (8  Winkey)
///-----------------------------------------------------------------
function ModToStr(X:Byte):string;
var s:string;
begin
s:='';
if (x and 1)<>0 then s:=s+'Alt+';
if (x and 2)<>0 then s:=s+'Ctrl+';
if (x and 4)<>0 then s:=s+'Shift+';
if (x and 8)<>0 then s:=s+'Win+';
result:=s;
end;
///-----------------------------------------------------------------

// 
///-----------------------------------------------------------------
procedure RegHotKeys(Hwnd:THandle);
var i:Integer;// hwnd:THandle;
begin
//   hwnd:=GetMyPanel(GetTCHWnd,CmdEdit);
for i:=0 to HotKeyList.Count-1 do
if THKeyType(HotKeyList.Objects[i]).SendOrNot=1 then
 begin
   THKeyType(HotKeyList.Objects[i]).id:= GlobalAddAtom(Pchar(THKeyType(HotKeyList.Objects[i]).action));

  RegisterHotKey(hwnd, THKeyType(HotKeyList.Objects[i]).id, THKeyType(HotKeyList.Objects[i]).Modifiers, THKeyType(HotKeyList.Objects[i]).Key);
  HotKeyList.Strings[i]:=IntToStr(THKeyType(HotKeyList.Objects[i]).id);
 end;

end;
///-----------------------------------------------------------------

// 
///-----------------------------------------------------------------
procedure UnRegHotKeys(Hwnd:THandle);
var i:Integer;//hwnd:THandle;
begin
//   hwnd:=GetMyPanel(GetTCHWnd,CmdEdit);

if HotKeyList.Count>0 then
for i:=0 to HotKeyList.Count-1 do
//if THKeyType(HotKeyList.Objects[i]).SendOrNot=1 then
 begin
  UnRegisterHotKey(hwnd, THKeyType(HotKeyList.Objects[i]).id);
  GlobalDeleteAtom(THKeyType(HotKeyList.Objects[i]).id);
 end;
end;
///-----------------------------------------------------------------


//   
///-----------------------------------------------------------------
procedure SaveHotKeys;
var i:Integer; hkr:string; HkL:TStringList; WhereToWork,PreventSending:Byte;
begin
{  }
try
HkL:=TStringList.Create;
For i:=0 to HotKeyList.Count-1 do
 begin
   hkr:=IntToStr(THKeyType(HotKeyList.Objects[i]).Modifiers)+'+'+inttostr(THKeyType(HotKeyList.Objects[i]).key);

   WhereToWork:=THKeyType(HotKeyList.Objects[i]).BothConTC;
   PreventSending:=THKeyType(HotKeyList.Objects[i]).SendOrNot;
   HkL.Add(THKeyType(HotKeyList.Objects[i]).Action+'='+HKr+'whr='+inttostr(WhereToWork)+'prv='+inttostr(PreventSending));
 end;
 HkL.SaveToFile(ExtractFilePath(PathToWDX)+'HotKeys.hks');
finally
  HkL.Free;
end;

end;
///-----------------------------------------------------------------

//   
///-----------------------------------------------------------------
procedure GetWhrAndPrv(str:string;var WhereToWork,PreventSending:byte);
var s,s1:string;
begin
s:='';
s1:='';

if (Pos('prv=',str)>0) then
 begin
  s1:=Copy(str,Pos('prv=',str)+4,1);
 end;

if (Pos('whr=',str)>0) then
 begin
  s:=Copy(str,Pos('whr=',str)+4,1);
 end;

  if s='' then s:='0';
  WhereToWork:=StrToInt(s);

  if s1='' then s1:='0';
  PreventSending:=StrToInt(s1);

end;
///-----------------------------------------------------------------

//   
///-----------------------------------------------------------------
procedure GetHotPrm(str:string;var Listo:TStringList);
var s:string;
begin

end;
///-----------------------------------------------------------------

//   
///-----------------------------------------------------------------
procedure LoadHotKeys(Hwnd:THandle);
var i,x:Integer; hkr,s:string; hkl:TStringList;   WhereToWork,PreventSending:Byte;
begin

// 
///---------------
UnRegHotKeys(Hwnd);;

 if Assigned(HotKeyList) then
 begin
   while HotKeyList.Count>0 do
    begin
      if Assigned(THKeyType(HotKeyList.Objects[0])) then
     THKeyType(HotKeyList.Objects[0]).Free;
     HotKeyList.Delete(0);
    end;
 end;
///---------------

{   }
try
Hkl:=TStringList.Create;
if not FileExists(ExtractFilePath(PathToWDX)+'HotKeys.hks')then Exit;
HkL.LoadFromFile(ExtractFilePath(PathToWDX)+'HotKeys.hks');

For i:=0 to HKL.Count-1 do
 begin

    hkr:=hkl.Strings[i];
    s:=Copy(hkr,Pos('whr=',hkr),Length(hkr)+1-Pos('whr=',hkr));
    Delete(hkr,Pos('whr=',hkr),Length(hkr)-Pos('whr=',hkr)+1);
    hkl.Strings[i]:=hkr;
    hkr:='';

//Delete(s,1,4);
    GetWhrAndPrv(s,WhereToWork,PreventSending);
    hkr:=hkl.ValueFromIndex[i];

    HotKeyList.AddObject(Copy(hkr,1,Pos('+',hkr)-1)+'+'+Copy(hkr,Pos('+',hkr)+1,Length(hkr)-Pos('+',hkr)+1),TObject(THKeyType.Create));
    THKeyType(HotKeyList.Objects[i]).Create;

  THKeyType(HotKeyList.Objects[i]).BothConTC:=WhereToWork; //
    THKeyType(HotKeyList.Objects[i]).SendOrNot:=PreventSending; //

    THKeyType(HotKeyList.Objects[i]).Action:=hkl.Names[i];

    THKeyType(HotKeyList.Objects[i]).Modifiers:=StrToInt(Copy(hkr,1,Pos('+',hkr)-1));
    THKeyType(HotKeyList.Objects[i]).Key:=StrToInt(Copy(hkr,Pos('+',hkr)+1,Length(hkr)-Pos('+',hkr)+1));

 end;
if Hwnd<>0 then  RegHotKeys(Hwnd);
finally
hkl.Free;
end;


end;
///-----------------------------------------------------------------


initialization
 HotKeyList:=TStringList.Create;

finalization

 if Assigned(HotKeyList) then
 begin
   while HotKeyList.Count>0 do
    begin
      if Assigned(THKeyType(HotKeyList.Objects[0])) then
     THKeyType(HotKeyList.Objects[0]).Free;
     HotKeyList.Delete(0);
    end;
  HotKeyList.Free;
 end;
end.