//============================================================
//By Dmitry Kolomiets aka B4rr4cuda
//B4rr4cuda@rambler.ru
//============================================================

program TCSE;

type
  HWND = type LongWord;
  DWORD = LongWord;
  UINT = LongWord;
    WPARAM = Longint;
    LPARAM = Longint;
    LRESULT = Longint;
    BOOL = LongBool;
  _FILETIME = record
    dwLowDateTime: DWORD;
    dwHighDateTime: DWORD;
  end;
  TFileTime = _FILETIME;
  FILETIME = _FILETIME;


type
  PWin32FindDataA = ^TWin32FindDataA;
  PWin32FindData = PWin32FindDataA;
  _WIN32_FIND_DATAA = record
    dwFileAttributes: DWORD;
    ftCreationTime: TFileTime;
    ftLastAccessTime: TFileTime;
    ftLastWriteTime: TFileTime;
    nFileSizeHigh: DWORD;
    nFileSizeLow: DWORD;
    dwReserved0: DWORD;
    dwReserved1: DWORD;
    cFileName: array[0..260 - 1] of AnsiChar;
    cAlternateFileName: array[0..13] of AnsiChar;
  end;
  _WIN32_FIND_DATA = _WIN32_FIND_DATAA;
  TWin32FindDataA = _WIN32_FIND_DATAA;
  TWin32FindData = TWin32FindDataA;

  LongRec = packed record
    case Integer of
      0: (Lo, Hi: Word);
      1: (Words: array [0..1] of Word);
      2: (Bytes: array [0..3] of Byte);
  end;



function GetForegroundWindow: HWND; stdcall; external 'user32.dll' name 'GetForegroundWindow';
function RealGetWindowClass(hwnd: HWND; pszType: PChar; cchType: UINT): UINT; stdcall; external 'user32.dll' name 'RealGetWindowClassA';
function FindWindowEx(Parent, Child: HWND; ClassName, WindowName: PChar): HWND; stdcall; external 'user32.dll' name 'FindWindowExA';
function PostMessage(hWnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): BOOL; stdcall; external 'user32.dll' name 'PostMessageA';
function FindFirstFile(lpFileName: PChar; var lpFindFileData: TWIN32FindData): THandle; stdcall; external 'kernel32.dll' name 'FindFirstFileA';
function FindClose(hFindFile: THandle): BOOL; stdcall; external 'kernel32.dll' name 'FindClose';
function FileTimeToLocalFileTime(const lpFileTime: TFileTime; var lpLocalFileTime: TFileTime): BOOL; stdcall; external 'kernel32.dll' name 'FileTimeToLocalFileTime';
function FileTimeToDosDateTime(const lpFileTime: TFileTime; var lpFatDate, lpFatTime: Word): BOOL; stdcall; external 'kernel32.dll' name 'FileTimeToDosDateTime';



function FileAgeX(const FileName: string): Integer;
var
  Handle: THandle;
  FindData: TWin32FindData;
  LocalFileTime: TFileTime;
begin
  Handle := FindFirstFile(PChar(FileName), FindData);
  if Handle <> DWORD(-1) then
  begin
    FindClose(Handle);
    if (FindData.dwFileAttributes and $00000010) = 0 then
    begin
      FileTimeToLocalFileTime(FindData.ftLastWriteTime, LocalFileTime);
      if FileTimeToDosDateTime(LocalFileTime, LongRec(Result).Hi,
        LongRec(Result).Lo) then Exit;
    end;
  end;
  Result := -1;
end;

function FileExists(const FileName: string): Boolean;
begin
  Result := FileAgeX(FileName) <> -1;
end;


function ExtrFPath(FileName:string):string;
var backup,s,path:string; poz:Integer;
begin
  path:=FileName;
  if Length(Path)>0 then
    begin
      backup:=Path;
      s:=Path;
      if Pos('\',s)>0 then
        begin
          poz:=Pos('\',s);
          while Pos('\',s)>0 do
            begin
             Delete(s,1,Pos('\',s));
             if Pos('\',s)>0 then poz:=poz+Pos('\',s);
            end;
          result:=Copy(Path, 1, poz);
        end else Result:='';
    end else result:='';
end;

function StrToInt(const S: string): Integer;
var  E: Integer;
begin
  Val(S, Result, E);
end;

function StrPas(const Str: PChar): string;
begin
  Result := Str;
end;

function LowerCase(const S: string): string;
var
  Ch: Char;
  L: Integer;
  Source, Dest: PChar;
begin
  L := Length(S);
  SetLength(Result, L);
  Source := Pointer(S);
  Dest := Pointer(Result);
  while L <> 0 do
  begin
    Ch := Source^;
    if (Ch >= 'A') and (Ch <= 'Z') then Inc(Ch, 32);
    Dest^ := Ch;
    Inc(Source);
    Inc(Dest);
    Dec(L);
  end;
end;


var TcH:THandle;
    s,tp,st:string;
    prm:PChar;
    cmd:Integer;
    f:TextFile;

begin
  s:=ParamStr(1);
  if Length(s)=0 then Exit;

  if not (s[1]  in ['1','2','3','4','5','6','7','8','9','0']) then
    begin
      { TODO :     }
      tp:=ParamStr(0);
      tp:=ExtrFPath(tp)+'CommandList.inc';
      s:=LowerCase(s);
      if FileExists(tp) then
        begin
          AssignFile(f,tp);
          Reset(f);
            while not Eof(f) do
              begin
                Readln(f,st);
                st:=Lowercase(st);
                if Pos(s,st)>0 then
                  cmd:=StrToInt(Copy(st,1,-1+Pos('=',st)));
              end;
          CloseFile(f);
        end else Exit;
    end
  else  cmd:=StrToInt(s);


      TcH:=GetForegroundWindow;
      GetMem(prm,256);
      RealGetWindowClass(TcH,prm,256);
      tp:=StrPas(prm);
      FreeMem(prm);
      if tp='TTOTAL_CMD' then
        begin
          {   }
          PostMessage(FindWindowEx(TCH,0,'TFKon','TotalConsoleMain'),$0400+182,cmd,0);
        end;



end.