unit VirtualKeys;

interface
uses sysutils,windows;
const
  {$EXTERNALSYM VK_LBUTTON}
  VK_LBUTTON = 1;
  {$EXTERNALSYM VK_RBUTTON}
  VK_RBUTTON = 2;
  {$EXTERNALSYM VK_CANCEL}
  VK_CANCEL = 3;
  {$EXTERNALSYM VK_MBUTTON}
  VK_MBUTTON = 4;  { NOT contiguous with L & RBUTTON }
  {$EXTERNALSYM VK_XBUTTON1}
  VK_XBUTTON1 = 5;
  {$EXTERNALSYM VK_XBUTTON2}
  VK_XBUTTON2 = 6;
  {$EXTERNALSYM VK_BACK}
  VK_BACK = 8;
  {$EXTERNALSYM VK_TAB}
  VK_TAB = 9;
  {$EXTERNALSYM VK_CLEAR}
  VK_CLEAR = 12;
  {$EXTERNALSYM VK_RETURN}
  VK_RETURN = 13;
  {$EXTERNALSYM VK_SHIFT}
  VK_SHIFT = $10;
  {$EXTERNALSYM VK_CONTROL}
  VK_CONTROL = 17;
  {$EXTERNALSYM VK_MENU}
  VK_MENU = 18;
  {$EXTERNALSYM VK_PAUSE}
  VK_PAUSE = 19;
  {$EXTERNALSYM VK_CAPITAL}
  VK_CAPITAL = 20;
  {$EXTERNALSYM VK_KANA }
  VK_KANA = 21;
  {$EXTERNALSYM VK_HANGUL }
  VK_HANGUL = 21;
  {$EXTERNALSYM VK_JUNJA }
  VK_JUNJA = 23;
  {$EXTERNALSYM VK_FINAL }
  VK_FINAL = 24;
  {$EXTERNALSYM VK_HANJA }
  VK_HANJA = 25;
  {$EXTERNALSYM VK_KANJI }
  VK_KANJI = 25;
  {$EXTERNALSYM VK_CONVERT }
  VK_CONVERT = 28;
  {$EXTERNALSYM VK_NONCONVERT }
  VK_NONCONVERT = 29;
  {$EXTERNALSYM VK_ACCEPT }
  VK_ACCEPT = 30;
  {$EXTERNALSYM VK_MODECHANGE }
  VK_MODECHANGE = 31;
  {$EXTERNALSYM VK_ESCAPE}
  VK_ESCAPE = 27;
  {$EXTERNALSYM VK_SPACE}
  VK_SPACE = $20;
  {$EXTERNALSYM VK_PRIOR}
  VK_PRIOR = 33;
  {$EXTERNALSYM VK_NEXT}
  VK_NEXT = 34;
  {$EXTERNALSYM VK_END}
  VK_END = 35;
  {$EXTERNALSYM VK_HOME}
  VK_HOME = 36;
  {$EXTERNALSYM VK_LEFT}
  VK_LEFT = 37;
  {$EXTERNALSYM VK_UP}
  VK_UP = 38;
  {$EXTERNALSYM VK_RIGHT}
  VK_RIGHT = 39;
  {$EXTERNALSYM VK_DOWN}
  VK_DOWN = 40;
  {$EXTERNALSYM VK_SELECT}
  VK_SELECT = 41;
  {$EXTERNALSYM VK_PRINT}
  VK_PRINT = 42;
  {$EXTERNALSYM VK_EXECUTE}
  VK_EXECUTE = 43;
  {$EXTERNALSYM VK_SNAPSHOT}
  VK_SNAPSHOT = 44;
  {$EXTERNALSYM VK_INSERT}
  VK_INSERT = 45;
  {$EXTERNALSYM VK_DELETE}
  VK_DELETE = 46;
  {$EXTERNALSYM VK_HELP}
  VK_HELP = 47;
{ VK_0 thru VK_9 are the same as ASCII '0' thru '9' ($30 - $39) }
{ VK_A thru VK_Z are the same as ASCII 'A' thru 'Z' ($41 - $5A) }
  {$EXTERNALSYM VK_LWIN}
  VK_LWIN = 91;
  {$EXTERNALSYM VK_RWIN}
  VK_RWIN = 92;
  {$EXTERNALSYM VK_APPS}
  VK_APPS = 93;
  {$EXTERNALSYM VK_SLEEP}
  VK_SLEEP = 95;
  {$EXTERNALSYM VK_NUMPAD0}
  VK_NUMPAD0 = 96;
  {$EXTERNALSYM VK_NUMPAD1}
  VK_NUMPAD1 = 97;
  {$EXTERNALSYM VK_NUMPAD2}
  VK_NUMPAD2 = 98;
  {$EXTERNALSYM VK_NUMPAD3}
  VK_NUMPAD3 = 99;
  {$EXTERNALSYM VK_NUMPAD4}
  VK_NUMPAD4 = 100;
  {$EXTERNALSYM VK_NUMPAD5}
  VK_NUMPAD5 = 101;
  {$EXTERNALSYM VK_NUMPAD6}
  VK_NUMPAD6 = 102;
  {$EXTERNALSYM VK_NUMPAD7}
  VK_NUMPAD7 = 103;
  {$EXTERNALSYM VK_NUMPAD8}
  VK_NUMPAD8 = 104;
  {$EXTERNALSYM VK_NUMPAD9}
  VK_NUMPAD9 = 105;
  {$EXTERNALSYM VK_MULTIPLY}
  VK_MULTIPLY = 106;
  {$EXTERNALSYM VK_ADD}
  VK_ADD = 107;
  {$EXTERNALSYM VK_SEPARATOR}
  VK_SEPARATOR = 108;
  {$EXTERNALSYM VK_SUBTRACT}
  VK_SUBTRACT = 109;
  {$EXTERNALSYM VK_DECIMAL}
  VK_DECIMAL = 110;
  {$EXTERNALSYM VK_DIVIDE}
  VK_DIVIDE = 111;
  {$EXTERNALSYM VK_F1}
  VK_F1 = 112;
  {$EXTERNALSYM VK_F2}
  VK_F2 = 113;
  {$EXTERNALSYM VK_F3}
  VK_F3 = 114;
  {$EXTERNALSYM VK_F4}
  VK_F4 = 115;
  {$EXTERNALSYM VK_F5}
  VK_F5 = 116;
  {$EXTERNALSYM VK_F6}
  VK_F6 = 117;
  {$EXTERNALSYM VK_F7}
  VK_F7 = 118;
  {$EXTERNALSYM VK_F8}
  VK_F8 = 119;
  {$EXTERNALSYM VK_F9}
  VK_F9 = 120;
  {$EXTERNALSYM VK_F10}
  VK_F10 = 121;
  {$EXTERNALSYM VK_F11}
  VK_F11 = 122;
  {$EXTERNALSYM VK_F12}
  VK_F12 = 123;
  {$EXTERNALSYM VK_F13}
  VK_F13 = 124;
  {$EXTERNALSYM VK_F14}
  VK_F14 = 125;
  {$EXTERNALSYM VK_F15}
  VK_F15 = 126;
  {$EXTERNALSYM VK_F16}
  VK_F16 = 127;
  {$EXTERNALSYM VK_F17}
  VK_F17 = 128;
  {$EXTERNALSYM VK_F18}
  VK_F18 = 129;
  {$EXTERNALSYM VK_F19}
  VK_F19 = 130;
  {$EXTERNALSYM VK_F20}
  VK_F20 = 131;
  {$EXTERNALSYM VK_F21}
  VK_F21 = 132;
  {$EXTERNALSYM VK_F22}
  VK_F22 = 133;
  {$EXTERNALSYM VK_F23}
  VK_F23 = 134;
  {$EXTERNALSYM VK_F24}
  VK_F24 = 135;
  {$EXTERNALSYM VK_NUMLOCK}
  VK_NUMLOCK = 144;
  {$EXTERNALSYM VK_SCROLL}
  VK_SCROLL = 145;
{ VK_L & VK_R - left and right Alt, Ctrl and Shift virtual keys.
  Used only as parameters to GetAsyncKeyState() and GetKeyState().
  No other API or message will distinguish left and right keys in this way. }
  {$EXTERNALSYM VK_LSHIFT}
  VK_LSHIFT = 160;
  {$EXTERNALSYM VK_RSHIFT}
  VK_RSHIFT = 161;
  {$EXTERNALSYM VK_LCONTROL}
  VK_LCONTROL = 162;
  {$EXTERNALSYM VK_RCONTROL}
  VK_RCONTROL = 163;
  {$EXTERNALSYM VK_LMENU}
  VK_LMENU = 164;
  {$EXTERNALSYM VK_RMENU}
  VK_RMENU = 165;

  {$EXTERNALSYM VK_BROWSER_BACK}
  VK_BROWSER_BACK = 166;
  {$EXTERNALSYM VK_BROWSER_FORWARD}
  VK_BROWSER_FORWARD = 167;
  {$EXTERNALSYM VK_BROWSER_REFRESH}
  VK_BROWSER_REFRESH = 168;
  {$EXTERNALSYM VK_BROWSER_STOP}
  VK_BROWSER_STOP = 169;
  {$EXTERNALSYM VK_BROWSER_SEARCH}
  VK_BROWSER_SEARCH = 170;
  {$EXTERNALSYM VK_BROWSER_FAVORITES}
  VK_BROWSER_FAVORITES = 171;
  {$EXTERNALSYM VK_BROWSER_HOME}
  VK_BROWSER_HOME = 172;
  {$EXTERNALSYM VK_VOLUME_MUTE}
  VK_VOLUME_MUTE = 173;
  {$EXTERNALSYM VK_VOLUME_DOWN}
  VK_VOLUME_DOWN = 174;
  {$EXTERNALSYM VK_VOLUME_UP}
  VK_VOLUME_UP = 175;
  {$EXTERNALSYM VK_MEDIA_NEXT_TRACK}
  VK_MEDIA_NEXT_TRACK = 176;
  {$EXTERNALSYM VK_MEDIA_PREV_TRACK}
  VK_MEDIA_PREV_TRACK = 177;
  {$EXTERNALSYM VK_MEDIA_STOP}
  VK_MEDIA_STOP = 178;
  {$EXTERNALSYM VK_MEDIA_PLAY_PAUSE}
  VK_MEDIA_PLAY_PAUSE = 179;
  {$EXTERNALSYM VK_LAUNCH_MAIL}
  VK_LAUNCH_MAIL = 180;
  {$EXTERNALSYM VK_LAUNCH_MEDIA_SELECT}
  VK_LAUNCH_MEDIA_SELECT = 181;
  {$EXTERNALSYM VK_LAUNCH_APP1}
  VK_LAUNCH_APP1 = 182;
  {$EXTERNALSYM VK_LAUNCH_APP2}
  VK_LAUNCH_APP2 = 183;

  {$EXTERNALSYM VK_OEM_1}
  VK_OEM_1 = 186;
  {$EXTERNALSYM VK_OEM_PLUS}
  VK_OEM_PLUS = 187;
  {$EXTERNALSYM VK_OEM_COMMA}
  VK_OEM_COMMA = 188;
  {$EXTERNALSYM VK_OEM_MINUS}
  VK_OEM_MINUS = 189;
  {$EXTERNALSYM VK_OEM_PERIOD}
  VK_OEM_PERIOD = 190;
  {$EXTERNALSYM VK_OEM_2}
  VK_OEM_2 = 191;
  {$EXTERNALSYM VK_OEM_3}
  VK_OEM_3 = 192;
  {$EXTERNALSYM VK_OEM_4}
  VK_OEM_4 = 219;
  {$EXTERNALSYM VK_OEM_5}
  VK_OEM_5 = 220;
  {$EXTERNALSYM VK_OEM_6}
  VK_OEM_6 = 221;
  {$EXTERNALSYM VK_OEM_7}
  VK_OEM_7 = 222;
  {$EXTERNALSYM VK_OEM_8}
  VK_OEM_8 = 223;
  {$EXTERNALSYM VK_OEM_102}
  VK_OEM_102 = 226;
  {$EXTERNALSYM VK_PACKET}
  VK_PACKET = 231;
  {$EXTERNALSYM VK_PROCESSKEY}
  VK_PROCESSKEY = 229;
  {$EXTERNALSYM VK_ATTN}
  VK_ATTN = 246;
  {$EXTERNALSYM VK_CRSEL}
  VK_CRSEL = 247;
  {$EXTERNALSYM VK_EXSEL}
  VK_EXSEL = 248;
  {$EXTERNALSYM VK_EREOF}
  VK_EREOF = 249;
  {$EXTERNALSYM VK_PLAY}
  VK_PLAY = 250;
  {$EXTERNALSYM VK_ZOOM}
  VK_ZOOM = 251;
  {$EXTERNALSYM VK_NONAME}
  VK_NONAME = 252;
  {$EXTERNALSYM VK_PA1}
  VK_PA1 = 253;
  {$EXTERNALSYM VK_OEM_CLEAR}
  VK_OEM_CLEAR = 254;

function StringToVirtualKeyCode (Key:String):Integer;
Function VirtualKeyCodeToString (VK_CODE:Integer; Diff_LR:Boolean=true):String;
Procedure GetKeyStrokeParams (KeyStroke:Integer; var RepeatCount:Word;
                              var ScanCode:Byte; var ExtendedFlag:Boolean;
                              var ContextCode:Boolean;var PreviousKeyState:Boolean;
                              var TransitionState:boolean);
function KeyPressed(Key:Integer):Boolean;
Function KeyToStr(Key:integer; Var KeysCount:Byte;DiffersMod:Boolean=true):String;
function CountBits(const Value: Integer): Integer;
function IsBit(Value, Pos: Integer): Boolean;
function SetBit(const Value, Pos: Integer): Integer;
Function Int2BinStr (int:integer):string;



implementation


function KeyPressed(Key:Integer):Boolean;
begin
  result:=(GetKeyState(key)and 128)=128;
end;

Function KeyToStr(Key:integer; Var KeysCount:Byte;DiffersMod:Boolean=true):String;
var
i:byte;
VK_STRING:string;
begin
KeysCount:=0;
if key=0 then exit;
for i:=1 to 255 do
 begin
 if KeyPressed (i) then
  begin
  VK_STRING:=VirtualKeyCodeToString(i,DiffersMod);
  if (VK_STRING='') then continue;
  if (VK_STRING[1]='+') then delete(VK_STRING,1,1);
  result:=Result+'+'+VK_STRING;
  if result[1]='+' then delete(result,1,1);
  inc (KeysCount);
  end;
 end;
if result='' then
 begin
 result:=IntTostr(key);
 end;
end;

function CountBits(const Value: Integer): Integer;
asm
 mov ECX,EAX
 xor EAX,EAX
 test ECX,ECX
 jz @@ending
 @@counting:
 shr ECX,1
 adc EAX,0
 test ECX,ECX
 jnz @@counting
 @@ending:
end;

function IsBit(Value, Pos: Integer): Boolean;
 asm
 mov ECX,EAX
 xor EAX,EAX
 and EDX,31
 bt ECX,EDX
 adc EAX,0
 end;

function SetBit(const Value, Pos: Integer): Integer;
 asm
 and EDX,31
 bts EAX,EDX
 end;

Function Int2BinStr (int:integer):string;
var
i: integer;
begin
  result := '';
  for i := 0 to 31 do begin
    if IsBit (int,i) then
      result:='1' + result
      else result:='0' + result;
  end;
Result:=Result+' - '+inttostr(CountBits(int));
end;

Procedure GetKeyStrokeParams (KeyStroke:Integer; var RepeatCount:Word;
 var ScanCode:Byte; var ExtendedFlag:Boolean;var ContextCode:Boolean;var PreviousKeyState:Boolean;
 var TransitionState:boolean);
var
i: integer;
Begin
ScanCode:=0;
RepeatCount:=0;
TransitionState :=IsBit (KeyStroke,31);
PreviousKeyState :=IsBit (KeyStroke,30);
ContextCode :=IsBit (KeyStroke,29);
ExtendedFlag:=IsBit (KeyStroke,24);
for i:=16 to 23 do
 begin
 if IsBit (KeyStroke,i) then ScanCode := SetBit (ScanCode,i-16);
 end;
for i:=0 to 15 do
 begin
 if IsBit (KeyStroke,i) then RepeatCount := SetBit (RepeatCount,i);
 end;
end;

 Function VirtualKeyCodeToString (VK_CODE:Integer; Diff_LR:Boolean=true):String;
// ,  ,      :)...
Begin
result:='';
if Diff_LR then
 begin
  Case VK_CODE of
   VK_LCONTROL: Result:='LCtrl';
   VK_RCONTROL: Result:='RCtrl';
   VK_LMENU: Result:='LAlt';
   VK_RMENU: Result:='RAlt';
   VK_LSHIFT: Result:='LShift';
   VK_RSHIFT: Result:='RShift';
   VK_LWIN: Result:='LWin';
   VK_RWIN: Result:='RWin';
  end;
 end else
 begin
  Case VK_CODE of
   VK_CONTROL: Result:='Ctrl';
   VK_MENU: Result:='Alt';
   VK_SHIFT: Result:='Shift';
   VK_LWIN, VK_RWIN: Result:='Win';
  end;// case
 end;
Case VK_CODE of
 VK_BACK: result:='Back';
 VK_TAB: result:='Tab';
 VK_CLEAR: result:='Clear';
 VK_RETURN: result:='Enter';
 VK_PAUSE: result:='Pause';
 VK_CAPITAL: result:='Caps Lock';
 VK_KANA: result:='Kana';
 VK_JUNJA: result:='Junja';
 VK_FINAL: result:='Final';
 VK_HANJA: result:='Hanja';
 VK_CONVERT: result:='Convert';
 VK_NONCONVERT: result:='Nonconvert';
 VK_ACCEPT: result:='Accept';
 VK_MODECHANGE: result:='Modechange';
 VK_ESCAPE: result:='Esc';
 VK_SPACE: result:='Space';
 VK_PRIOR: result:='PgUp';
 VK_NEXT: result:='PgDown';
 VK_END: result:='End';
 VK_HOME: result:='Home';
 VK_LEFT: result:='Left';
 VK_UP: result:='Up';
 VK_RIGHT: result:='Right';
 VK_DOWN: result:='Down';
 VK_SELECT: result:='Select';
 VK_PRINT: result:='Print';
 VK_EXECUTE: result:='Execute';
 VK_SNAPSHOT: result:='Print Scr'; //    
 VK_INSERT: result:='Ins';
 VK_DELETE: result:='Del';
 VK_HELP: result:='Help';
 VK_APPS: result:='Apps';
 VK_NUMPAD0: result:='Num 0';
 VK_NUMPAD1: result:='Num 1';
 VK_NUMPAD2: result:='Num 2';
 VK_NUMPAD3: result:='Num 3';
 VK_NUMPAD4: result:='Num 4';
 VK_NUMPAD5: result:='Num 5';
 VK_NUMPAD6: result:='Num 6';
 VK_NUMPAD7: result:='Num 7';
 VK_NUMPAD8: result:='Num 8';
 VK_NUMPAD9: result:='Num 9';
 VK_MULTIPLY: result:='Mul';
 VK_ADD: result:='Add';
 VK_SEPARATOR: result:='Sep';
 VK_SUBTRACT: result:='Sub';
 VK_DECIMAL: result:='Dec';
 VK_DIVIDE: result:='Div';
 VK_F1: result:='F1';
 VK_F2: result:='F2';
 VK_F3: result:='F3';
 VK_F4: result:='F4';
 VK_F5: result:='F5';
 VK_F6: result:='F6';
 VK_F7: result:='F7';
 VK_F8: result:='F8';
 VK_F9: result:='F9';
 VK_F10: result:='F10';
 VK_F11: result:='F11';
 VK_F12: result:='F12';
 VK_F13: result:='F13';
 VK_F14: result:='F14';
 VK_F15: result:='F15';
 VK_F16: result:='F16';
 VK_F17: result:='F17';
 VK_F18: result:='F18';
 VK_F19: result:='F19';
 VK_F20: result:='F20';
 VK_F21: result:='F21';
 VK_F22: result:='F22';
 VK_F23: result:='F23';
 VK_F24: result:='F24';
 VK_NUMLOCK: result:='Num Lock';
 VK_SCROLL: result:='Scroll Lock';
 255: result:='Power';
 95: result:='Sleep';
 ord('A')..ord('Z'): result:=chr(VK_CODE);//
 ord('0')..ord('9'): result:=chr(VK_CODE);//
 VK_VOLUME_UP: result:='Volume Up';
 VK_VOLUME_DOWN: result:='Volume Down';
 VK_VOLUME_MUTE: result:='Mute';
 VK_BROWSER_BACK: result:='Browse Back';
 VK_BROWSER_FORWARD: result:='Browse Forward';
 VK_BROWSER_REFRESH: result:='Browse Refresh';
 VK_BROWSER_STOP: result:='Browse Stop';
 VK_BROWSER_SEARCH: result:='Search';
 VK_BROWSER_FAVORITES: result:='Favorites';
 VK_BROWSER_HOME: result:='Browse Home';
 VK_MEDIA_NEXT_TRACK: result:='Next';
 VK_MEDIA_PREV_TRACK: result:='Prev';
 VK_MEDIA_STOP: result:='Stop';
 VK_MEDIA_PLAY_PAUSE: result:='Play/Pause';
 VK_LAUNCH_MAIL: result:='Mail';
 VK_LAUNCH_MEDIA_SELECT: result:='Media Select';
 VK_LAUNCH_APP1: result:='Launch 1';
 VK_LAUNCH_APP2: result:='Launch 2';
 VK_OEM_1: result:=';'; //????
 VK_OEM_PLUS: result:='=';
 VK_OEM_COMMA: result:=',';
 VK_OEM_MINUS: result:='-';
 VK_OEM_PERIOD: result:='.';
 VK_OEM_2: result:='/';
 VK_OEM_3: result:='`';
 VK_OEM_4: result:='[';
 VK_OEM_5: result:='\';
 VK_OEM_6: result:=']';
 VK_OEM_7: result:='"';
// VK_OEM_8: result:='';             // ?
// VK_OEM_102: result:='';
 VK_PACKET: result:='Packet';
 VK_PROCESSKEY: result:='Processkey';
 VK_ATTN: result:='Attn';
 VK_CRSEL: result:='Crsel';
 VK_EXSEL: result:='Exsel';
 VK_EREOF: result:='Ereof';
 VK_PLAY: result:='Play';
 VK_ZOOM: result:='Zoom';
 VK_NONAME: result:='Noname';
 VK_PA1: result:='PA1';
 VK_OEM_CLEAR: result:='OEMClear';
end;
end;

function StringToVirtualKeyCode (Key:String):Integer;
begin
if (Length(key)=1)and((key[1] in ['A'..'Z']) or (key[1] in ['0'..'9'])) then
begin
 result:=ord(key[1]);
 Exit;
end;

key:=lowercase (key);
if (Length(key)=1)and((key[1] in ['a'..'z']) or (key[1] in ['0'..'9'])) then
result:=ord(key[1])
else //
if key='lctrl' then result:=VK_LCONTROL else
if key='rctrl' then result:=VK_RCONTROL else
if key='lalr' then result:=VK_LMENU else
if key='ralt' then result:=VK_RMENU else
if key='lshift' then result:=VK_LSHIFT else
if key='rshift' then result:=VK_RSHIFT else
if key='lwin' then result:=VK_LWIN else
if key='rwin' then result:=VK_RWIN else
if key='ctrl' then result:=VK_CONTROL else
if key='alt' then result:=VK_MENU else
if key='shift' then result:=VK_SHIFT else
if key='win' then result:=VK_LWIN else
if key='back' then result:=VK_BACK else
if key='tab' then
result:=VK_TAB else
if key='clear' then result:=VK_CLEAR else
if key='enter' then result:=VK_RETURN else
if key='pause' then result:=VK_PAUSE else
if key='caps lock' then result:=VK_CAPITAL else
if key='kana' then result:=VK_KANA else
if key='junja' then result:=VK_JUNJA else
if key='final' then result:=VK_FINAL else
if key='hanja' then result:=VK_HANJA else
if key='convert' then result:=VK_CONVERT else
if key='nonconvert' then result:=VK_NONCONVERT else
if key='accept' then result:=VK_ACCEPT else
if key='modechange' then result:=VK_MODECHANGE else
if key='esc' then result:=VK_ESCAPE else
if key='space' then result:=VK_SPACE else
if key='pgup' then result:=VK_PRIOR else
if key='pgdown' then result:=VK_NEXT else
if key='end' then result:=VK_END else
if key='home' then result:=VK_HOME else
if key='left' then result:=VK_LEFT else
if key='up' then result:=VK_UP else
if key='right' then result:=VK_RIGHT else
if key='down' then result:=VK_DOWN else
if key='select' then result:=VK_SELECT else
if key='print' then result:=VK_PRINT else
if key='execute' then result:=VK_EXECUTE else
if key='print scr' then result:=VK_SNAPSHOT else
if key='ins' then result:=VK_INSERT else
if key='delete' then result:=VK_DELETE else
if key='help' then result:=VK_HELP else
if key='apps' then result:=VK_APPS else
if key='num 0' then result:=VK_NUMPAD0 else
if key='num 1' then result:=VK_NUMPAD1 else
if key='num 2' then result:=VK_NUMPAD2 else
if key='num 3' then result:=VK_NUMPAD3 else
if key='num 4' then result:=VK_NUMPAD4 else
if key='num 5' then result:=VK_NUMPAD5 else
if key='num 6' then result:=VK_NUMPAD6 else
if key='num 7' then result:=VK_NUMPAD7 else
if key='num 8' then result:=VK_NUMPAD8 else
if key='num 9' then result:=VK_NUMPAD9 else
if key='mul' then result:=VK_MULTIPLY else
if key='add' then result:=VK_ADD else
if key='sep' then result:=VK_SEPARATOR else
if key='sub' then result:=VK_SUBTRACT else
if key='dec' then result:=VK_DECIMAL else
if key='div' then result:=VK_DIVIDE else
if key='f1' then result:=VK_F1 else
if key='f2' then result:=VK_F2 else
if key='f3' then result:=VK_F3 else
if key='f4' then result:=VK_F4 else
if key='f5' then
result:=VK_F5 else
if key='f6' then result:=VK_F6 else
if key='f7' then result:=VK_F7 else
if key='f8' then result:=VK_F8 else
if key='f9' then result:=VK_F9 else
if key='f10' then result:=VK_F10 else
if key='f11' then result:=VK_F11 else
if key='f12' then result:=VK_F12 else
if key='f13' then result:=VK_F13 else
if key='f14' then result:=VK_F14 else
if key='f15' then result:=VK_F15 else
if key='f16' then result:=VK_F16 else
if key='f17' then result:=VK_F17 else
if key='f18' then result:=VK_F18 else
if key='f19' then result:=VK_F19 else
if key='f20' then result:=VK_F10 else
if key='f21' then result:=VK_F21 else
if key='f22' then result:=VK_F22 else
if key='f23' then result:=VK_F23 else
if key='f24' then result:=VK_F24 else
if key='num lock' then result:=VK_NUMLOCK else
if key='scroll lock' then result:=VK_SCROLL else
if key='volume up' then result:=VK_VOLUME_UP else
if key='volume down' then result:=VK_VOLUME_DOWN else
if key='volume mute' then result:=VK_VOLUME_MUTE else
if key='browse back' then result:=VK_BROWSER_BACK else
if key='browse forward' then result:=VK_BROWSER_FORWARD else
if key='browse refresh' then result:=VK_BROWSER_REFRESH else
if key='browse stop' then result:=VK_BROWSER_STOP else
if key='search' then result:=VK_BROWSER_SEARCH else
if key='favorites' then result:=VK_BROWSER_FAVORITES else
if key='browse home' then result:=VK_BROWSER_HOME else
if key='next' then result:=VK_MEDIA_NEXT_TRACK else
if key='prev' then result:=VK_MEDIA_PREV_TRACK else
if key='stop' then result:=VK_MEDIA_STOP else
if key='play/pause' then result:=VK_MEDIA_PLAY_PAUSE else
if key='mail' then result:=VK_LAUNCH_MAIL else
if key='media select' then result:=VK_LAUNCH_MEDIA_SELECT else
if key='launch 1' then result:=VK_LAUNCH_APP1 else
if key='launch 2' then result:=VK_LAUNCH_APP2 else
if key=';' then result:=VK_OEM_1 else
if key='=' then result:=VK_OEM_PLUS else
if key=',' then result:=VK_OEM_COMMA else
if key='-' then result:=VK_OEM_MINUS else
if key='.' then result:=VK_OEM_PERIOD else
if key='/' then result:=VK_OEM_2 else
if key='`' then result:=VK_OEM_3 else
if key='[' then result:=VK_OEM_4 else
if key='\' then result:=VK_OEM_5 else
if key=']' then result:=VK_OEM_6 else
if key='"' then result:=VK_OEM_7 else
// VK_OEM_8: result:='';
// VK_OEM_102: result:='';
if key='packet' then result:=VK_PACKET else
if key='processkey' then result:=VK_PROCESSKEY else
if key='attn' then result:=VK_ATTN else
if key='crsel' then result:=VK_CRSEL else
if key='exsel' then result:=VK_EXSEL else
if key='ereof' then result:=VK_EREOF else
if key='play' then result:=VK_PLAY else
if key='zoom' then result:=VK_ZOOM else
if key='noname' then result:=VK_NONAME else
if key='pa1' then result:=VK_PA1 else
if key='clear' then result:=VK_OEM_CLEAR else
if key='power' then result:=255 else
if key='sleep' then result:=VK_SLEEP else
try
 result:=StrToInt(Key);   //    " "
except
 result:=0;
end;
end;

end.



