//============================================================
//By Dmitry Kolomiets aka B4rr4cuda
//B4rr4cuda@rambler.ru
//============================================================

unit Commands;

interface
uses  Windows, Messages, SysUtils, Classes;

var CommandList :TStringList; // 

procedure FillCommandList(PathX:String);                   //   
procedure ExportCommandList(PathX:string);                 //    
function StrAsAction(Action:string):Integer;               //  

implementation

//   
///-----------------------------------------------------------------
procedure FillCommandList(PathX:String);
var s:string; i:Integer;
begin

if FileExists(PathX+'CommandList.inc') then
 begin
  CommandList.LoadFromFile(PathX+'CommandList.inc');
   for i:=0 to CommandList.Count-1 do
    begin
     s:=CommandList[i];
     Delete(s,1,Pos('=',s));
     CommandList[i]:=s;
    end;
 end
else
 begin
  CommandList.Add('NextTab');
  CommandList.Add('PrevTab');
  CommandList.Add('CloseAll');
  CommandList.Add('CloseActive');
  CommandList.Add('Minimize');
  CommandList.Add('Hide');
  CommandList.Add('Show');
  CommandList.Add('Options');
  CommandList.Add('SetTCFocus');
  CommandList.Add('SetConsoleFocus');
  CommandList.Add('ExchangeFocus');
  CommandList.Add('NewConsole');
  CommandList.Add('Ctrl+O Imitation');
  CommandList.Add('Show\Hide');
  CommandList.Add('Maximize\Restore');
  CommandList.Add('Run Saved Console Count');
  CommandList.Add('CurrentPathToConsole');
 end;
end;
///-----------------------------------------------------------------

//    
///-----------------------------------------------------------------
procedure ExportCommandList(PathX:String);
var i:Integer; s:string;
begin
//CommandList.Insert(0,';Command Index=Command Name');
for i:=0 to CommandList.Count-1 do
begin
 s:='';
 s:=s+IntToStr(i)+'=';
 s:=s+CommandList.Strings[i];
 CommandList.Strings[i]:=s;
end;

 CommandList.SaveToFile(ExtractFilePath(PathX)+'CommandList.inc');
 CommandList.Clear;
 FillCommandList(PathX+'CommandList.inc');
end;
///-----------------------------------------------------------------

//  
///-----------------------------------------------------------------
function StrAsAction(Action:string):Integer;
begin
result:=CommandList.IndexOf(Action);
end;
///-----------------------------------------------------------------

initialization
 CommandList:=TStringList.Create;
finalization
//ExportCommandList('n:\TotaL_Plugins\TotalConsole\wdx_Konsole\');
 if Assigned(CommandList) then CommandList.free;
 
end.
 