//============================================================
//By Dmitry Kolomiets aka B4rr4cuda
//B4rr4cuda@rambler.ru
//============================================================

unit KeysCommands;

interface
uses  Windows, Messages, SysUtils, Classes;

var CommandList :TStringList; // 

procedure FillCommandList;                                 //   
procedure ExportCommandList(PathX:string);                 //    
function StrAsAction(Action:string):Integer;               //  

implementation
//   
///-----------------------------------------------------------------
procedure FillCommandList;
begin
//CommandList.Add('');
CommandList.Add('NextTab');
CommandList.Add('PrevTab');
CommandList.Add('CloseAll');
CommandList.Add('CloseActive');
CommandList.Add('Minimize');
CommandList.Add('Hide');
CommandList.Add('Show');
CommandList.Add('Options');
CommandList.Add('SetTCFocus');
CommandList.Add('SetConsoleFocus');
CommandList.Add('ExchangeFocus');
CommandList.Add('NewConsole');
CommandList.Add('Ctrl+O Imitation');
CommandList.Add('Show\Hide');
CommandList.Add('Maximize\Restore');
CommandList.Add('Run Saved Console Count');
CommandList.Add('CurrentPathToConsole');

end;
///-----------------------------------------------------------------

//    
///-----------------------------------------------------------------
procedure ExportCommandList(PathX:String);
var i:Integer; s:string;
begin
//CommandList.Insert(0,';Command Index=Command Name');
for i:=0 to CommandList.Count-1 do
begin
 s:='';
 s:=s+IntToStr(i)+'=';
 s:=s+CommandList.Strings[i];
 CommandList.Strings[i]:=s;
end;

 CommandList.SaveToFile(ExtractFilePath(PathX)+'CommandList.inc');
 CommandList.Clear;
 FillCommandList;
end;
///-----------------------------------------------------------------

//  
///-----------------------------------------------------------------
function StrAsAction(Action:string):Integer;
begin
result:=CommandList.IndexOf(Action);
end;
///-----------------------------------------------------------------

initialization
 CommandList:=TStringList.Create;
 FillCommandList;
finalization
//ExportCommandList('n:\TotaL_Plugins\TotalConsole\wdx_Konsole\');
 if Assigned(CommandList) then CommandList.free;
 
end.