//============================================================
//Total Commander's window cooperator
//By Dmitry Kolomiets aka B4rr4cuda
//B4rr4cuda@rambler.ru
//============================================================

unit TCWND;

interface
uses
  Windows, Messages, SysUtils, Classes;
///============================================================

var OrigTcWnd,OrigCmdWnd:TFNWndProc;
loger:TStringList;
Function GetTCWnd(WndList:TStrings):boolean;                     //       

Function GetTCMyLbWnd(MainWnd:THandle; var WLeft,WRight:THandle):boolean; // TMyListBox-  MainWnd

Function GetTCMyPWnd(MainWnd:THandle;WndList:TStrings; wndTabs:TStrings):boolean; // TMypanels-  TMyTabPanels  MainWnd
Function GetTCMyPcmdWnd(MainWnd:THandle;var WndText:String;var wnd:THandle):boolean; //Cmdtext label


type
  TMyPanelType=(MyPLeft,MyPRight,Cmd,
                CmdEdit,TreeLeftDiv,
                Divider,TreeRightDiv,
                ButtonBar,Lister,MyTree);
Function GetMyPanel(MainTCWnd:THandle; What:TMyPanelType):THandle;    //  

Function IsPanBoTop:boolean;                  //   ?
Procedure SetpansWidth(Width:integer);        //      
Procedure SetPansHeight(Height:integer);      // 
Procedure LessPansHeight(Height:integer);     //  
procedure SetTreeHeight(Correction:smallint);                        // 

Function GeTByH(H:THandle):String;            //GetTextByHandle   


Type
  TSize = packed record
    case Integer of
      0: (Left, Top, Right, Bottom: Longint);
      1: (Height,Width : LongInt);
  end;

Type TSizeKind=(PanLeft,PanTop,PanRight,PanBottom,PanWidth,PanHeight);

Function GetSizeOtn(Th:THandle):TSize; //         
Function GetSizeOfH(Th:THandle):TRect; //         (  )

Function GetXSizeofH(What:TSizeKind;Th:THandle):LongInt; //      
Function GetOXSizeofH(What:TSizeKind;Th:THandle):LongInt; //         

function GetClients(Pr:TPoint;Parent:THandle):TPoint; // 
Function GetCXSizeofH(What:TSizeKind;Parent,Th:THandle):LongInt; //        



Function CmpRect(r1,r2:TRect):boolean;                   //  TRect

type TDrvPanType=(DrvLeft,DrvRight);
Function GetDrvPan(Kind:TDrvPanType):THandle; // 

function GetTCHWnd: THandle;                  //  main  
procedure RereadPanel(hWnd: THandle);         //  (    )
procedure SendTCCommand(hWnd: THandle; Command:Integer);         //  

///============================================================

function GetSubSystem(Filename:Pchar):pchar; //  EXE (GUI,CUI(Console),Native,Unknown )
///-----------------------------------------------------------------

implementation

//uses Types;

function MyFindWindowEx(hwndParent,hwndChildAfter:hwnd;lpszClass,lpszWindow:pchar):hwnd;
var buf:array[0..259] of char;
begin
  result:=FindWindowEx(hwndParent,hwndChildAfter,lpszClass,lpszWindow);
  if (result=0) and (lpszClass<>nil) then begin
    strlcopy(buf,lpszClass,sizeof(buf)-1);
    strlcat(buf,'.UnicodeClass',sizeof(buf)-1);
    result:=FindWindowEx(hwndParent,hwndChildAfter,buf,lpszWindow);
  end;  
end;

///-----------------------------------------------------------------
//  
procedure SendTCCommand(hWnd: THandle; Command:Integer);
const
  EM_DISPLAYBAND = WM_USER+51;
  
begin
SendMessage(hWnd, EM_DISPLAYBAND, Command, 0);
end;
///-----------------------------------------------------------------

///-----------------------------------------------------------------
function IfThen(AValue: Boolean; const ATrue: Integer; const AFalse: Integer): Integer;
begin
  if AValue then
    Result := ATrue
  else
    Result := AFalse;
end;
///-----------------------------------------------------------------

// 
////-----------------------------------------------------------------
procedure SetTreeHeight(Correction:smallint);
var
    th,th1,mainT:THandle;
    wi,wi1:TagWindowInfo;
    siz:smallint;
begin
          //Tree
            th:=GetMyPanel(GetTCHWnd,TCWND.MyTree);
            if th>0 then
             begin
                //Right panel
              th1:=GetMyPanel(GetTCHWnd,TCWND.MyPRight);
              GetWindowInfo(th1,wi1);
              GetWindowInfo(th,wi);
              siz:=wi1.rcWindow.Bottom-wi.rcWindow.Top-Correction;
              SetWindowPos( th,HWND_TOp ,  0,0,  wi.rcWindow.Right-wi.rcWindow.Left, siz,SWP_NOMOVE);
            end;
end;
////-----------------------------------------------------------------



//  TRect
///-----------------------------------------------------------------
Function CmpRect(r1,r2:TRect):boolean;
begin
if (r1.Right-r1.Left<>r2.Right-r2.Left) or (r1.Bottom-r1.Top<>r2.Bottom-r2.Top) then
 result:=false else result:=true;
end;
///-----------------------------------------------------------------

// 
///-----------------------------------------------------------------
function GetClients(Pr:TPoint;Parent:THandle):TPoint;
var pt:TPoint;
begin
pt:=Pr;
  Windows.ScreenToClient(Parent,pt);
result:=pt;
end;
///-----------------------------------------------------------------

//        
///-----------------------------------------------------------------
Function GetCXSizeofH(What:TSizeKind;Parent,Th:THandle):LongInt;
var pt:TPoint;
    wi:TagWindowInfo;
begin
  GetWindowInfo(Th,wi);

 case What of
  PanLeft:result:=Getclients(wi.rcWindow.TopLeft,GettchWnd).X;
  PanTop:result:=Getclients(wi.rcWindow.TopLeft,GettchWnd).y;
  PanRight:result:=Getclients(wi.rcWindow.BottomRight,GettchWnd).X;
  PanBottom:result:=Getclients(wi.rcWindow.BottomRight,GettchWnd).y;
  PanWidth:result:=Getclients(wi.rcWindow.BottomRight,GettchWnd).X-Getclients(wi.rcWindow.TopLeft,GettchWnd).X;
  PanHeight:result:=Getclients(wi.rcWindow.BottomRight,GettchWnd).Y-Getclients(wi.rcWindow.TopLeft,GettchWnd).Y;
 end;

end;
///-----------------------------------------------------------------


//      
///-----------------------------------------------------------------
Function GetOXSizeofH(What:TSizeKind;Th:THandle):LongInt;
var r:TSize;
begin
r:=GetSizeOtn(Th);

 case What of
  PanLeft:result:=r.Left;
  PanTop:result:=r.Top;
  PanRight:result:=r.Right;
  PanBottom:result:=r.Bottom;
  PanWidth:result:=r.Width;
  PanHeight:result:=r.Height;
 end;

end;
///-----------------------------------------------------------------

//      
///-----------------------------------------------------------------
Function GetXSizeofH(What:TSizeKind;Th:THandle):LongInt;
var r:Trect;
begin
r:=GetSizeOfH(Th);

 case What of
  PanLeft:result:=r.Left;
  PanTop:result:=r.Top;
  PanRight:result:=r.Right;
  PanBottom:result:=r.Bottom;
  PanWidth:result:=r.Right-r.Left;
  PanHeight:result:=r.Bottom-r.Top;
 end;

end;

///-----------------------------------------------------------------
//         
///-----------------------------------------------------------------
Function GetSizeOtn(Th:THandle):TSize;
var wi,wiP:TagWindowInfo;
    Prnt:THandle;
begin
   GetWindowInfo(Th,wi);

    //
    Result.Width:=wi.rcWindow.Right-wi.rcWindow.Left;
    Result.Height:=wi.rcWindow.Bottom-wi.rcWindow.Top;

    //
     Prnt:=GetParent(Th);
     GetWindowInfo(Prnt,wiP);
     result.Left:=wi.rcWindow.Left-wiP.rcWindow.Left;
     result.Top:=wi.rcWindow.Top-wiP.rcWindow.Top;
     result.Bottom:=wi.rcWindow.Bottom-wiP.rcWindow.Top;
     result.Right:=wi.rcWindow.Right-wiP.rcWindow.Left;

end;
///-----------------------------------------------------------------

//       
///-----------------------------------------------------------------
Function GetSizeOfH(Th:THandle):TRect;
var wi:TagWindowInfo;
begin
   GetWindowInfo(Th,wi);
   result:=wi.rcWindow;
end;
///-----------------------------------------------------------------


//GetTextByHandle   
///-----------------------------------------------------------------
Function GeTByH(H:THandle):String;
var nm:Pchar;
begin
 getmem(nm,255);
 windows.GetWindowText(H,nm,255);
 result:=strpas(nm);
 freemem(nm);
end;
///-----------------------------------------------------------------

// 
///-----------------------------------------------------------------
Function GetDrvPan(Kind:TDrvPanType):THandle;
var wi0,wi1:TagWindowInfo;
    fir,sec,mainT:THandle;
    WLeft, WRight:THandle;
begin
 MainT:=GetTCHWnd;

 fir:=MyFindWindowEx(MainT,0,'TDrivePanel',nil);
 sec:=MyFindWindowEx(MainT,fir,'TDrivePanel',nil);
 if (fir=0) or (sec=0) then begin result:=0; exit; end;

   GetWindowInfo(Fir,wi0);
   GetWindowInfo(Sec,wi1);
  if wi0.rcWindow.Left<>wi1.rcWindow.Left then

          //    
          begin //---------------------------------
                  if wi0.rcWindow.Left<wi1.rcWindow.Left then
                   begin
                    WLeft:=Fir;
                    WRight:=sec;
                   end
                  else
                   begin
                    WLeft:=Sec;
                    WRight:=Fir;
                   end;
          end  //---------------------------------

   else
          //    
          begin //---------------------------------
                  if wi0.rcWindow.Top<wi1.rcWindow.Top then
                   begin
                    WLeft:=Fir;
                    WRight:=sec;
                   end
                  else
                   begin
                    WLeft:=Sec;
                    WRight:=Fir;
                   end;
         end;///-----------------------------------

 Case Kind of
 DrvLeft:result:=WLeft;
 DrvRight:result:=WRight;
 end;
end;
///-----------------------------------------------------------------


//      
///-----------------------------------------------------------------
Procedure SetPansWidth(Width:integer);
var wi:TagWindowInfo;
    th,mainT,Wl,Wr:THandle;
begin
  mainT:=GetTCHwnd;

  th:=GetMyPanel(mainT,TCWND.MyPLeft);
  GetWindowInfo(th,wi);
  SetWindowPos( th,HWND_BOTTOM ,  0,0, width ,wi.rcWindow.Bottom-wi.rcWindow.Top, SWP_NOMOVE);
  CloseHandle(Th);

  th:=GetMyPanel(mainT,TCWND.MyPRight);
  GetWindowInfo(th,wi);
  SetWindowPos( th,HWND_BOTTOM ,  0,0, width ,wi.rcWindow.Bottom-wi.rcWindow.Top, SWP_NOMOVE);
  CloseHandle(Th);

  //Divider
   th:=MyFindWindowEx(mainT,0,'TPanel',nil);
   GetWindowInfo(th,wi);
  SetWindowPos( th,HWND_BOTTOM ,  0,0, width ,wi.rcWindow.Bottom-wi.rcWindow.Top, SWP_NOMOVE);
  CloseHandle(Th);


 wl:=GetDrvPan(DrvLeft);
 wr:=GetDrvPan(DrvRight);
   GetWindowInfo(Wl,wi);
  SetWindowPos( Wl,HWND_BOTTOM ,  0,0, width ,wi.rcWindow.Bottom-wi.rcWindow.Top, SWP_NOMOVE);
   GetWindowInfo(Wr,wi);
  SetWindowPos( Wr,HWND_BOTTOM ,  0,0, width ,wi.rcWindow.Bottom-wi.rcWindow.Top, SWP_NOMOVE);
  CloseHandle(MainT);

end;
///-----------------------------------------------------------------

//    ?
///-----------------------------------------------------------------
Function IsPanBoTop:boolean;
var wi0,wi1:TagWindowInfo;
    th,mainT:THandle;
begin
  mainT:=GetTCHwnd;

  th:=GetMyPanel(mainT,TCWND.MyPLeft);
  GetWindowInfo(th,wi0);

  th:=GetMyPanel(mainT,TCWND.MyPRight);
  GetWindowInfo(th,wi1);

if wi0.rcWindow.Top<wi1.rcWindow.Top then result:=true else result:=false;
end;
///-----------------------------------------------------------------



//  
///-----------------------------------------------------------------
Procedure LessPansHeight(Height:integer);
var
    th,mainT:THandle;
    LL,LR:THandle;
    wi:TagWindowInfo;
    siz:smallint;
    x,y:Integer;
begin
  mainT:=GetTCHwnd;

  //GetWindowInfo(MainT,wi);
  {*********}
  siz:=Height;
  //((wi.rcWindow.Bottom-wi.rcWindow.Top))div 2; // 

  {       }
 if not IsPanBoTop then
  begin
   //Left panel
   th:=GetMyPanel(mainT,TCWND.MyPLeft);
   GetWindowInfo(th,wi);
   SetWindowPos( th,HWND_BOTTOM ,  0,0,  wi.rcWindow.Right-wi.rcWindow.Left,  wi.rcWindow.Bottom-wi.rcWindow.Top-Height,SWP_NOMOVE);

   //Right Panel
   th:=GetMyPanel(mainT,TCWND.MyPRight);
   GetWindowInfo(th,wi);
   SetWindowPos( th,HWND_BOTTOM ,  0,0,  wi.rcWindow.Right-wi.rcWindow.Left,  wi.rcWindow.Bottom-wi.rcWindow.Top-Height,SWP_NOMOVE);

   //Divider
   th:=GetMyPanel(mainT,TCWND.Divider);
   GetWindowInfo(th,wi);
   SetWindowPos( th,HWND_TOP ,  0,0, wi.rcWindow.Right-wi.rcWindow.Left,  wi.rcWindow.Bottom-wi.rcWindow.Top-Height,SWP_NOMOVE);

    //Lister
   th:=GetMyPanel(mainT,TCWND.Lister);
   GetWindowInfo(th,wi);
   SetWindowPos( th,HWND_TOP ,  0,0, wi.rcWindow.Right-wi.rcWindow.Left,  wi.rcWindow.Bottom-wi.rcWindow.Top-Height,SWP_NOMOVE);

   //Tree
   th:=GetMyPanel(GetTCHWnd,TCWND.MyTree);
   if th>0 then
    begin
   GetWindowInfo(th,wi);
   SetWindowPos( th,HWND_BOTTOM ,  0,0,  wi.rcWindow.Right-wi.rcWindow.Left, wi.rcWindow.Bottom-wi.rcWindow.Top-Height,SWP_NOMOVE);
    end;
  end else
   begin
{     x:=1;
     y:=GetXSizeofH(PanTop,GetMyPanel(GetTCHWnd,Divider));
     sendmessage(GetMyPanel(GetTCHWnd,Divider), WM_LBUTTONDOWN, MK_LBUTTON, x + y shl 16);
     y:=siz;
     sendmessage(GetMyPanel(GetTCHWnd,Divider), WM_LBUTTONUP, MK_LBUTTON, x + y shl 16);
   }
   end;

end;
//-----------------------------------------------------------------


// 
///-----------------------------------------------------------------
Procedure SetPansHeight(Height:integer);
var
    th,th1,mainT:THandle;
    wi,wi1:TagWindowInfo;
    siz:smallint;
    x,y:Integer;
begin
  mainT:=GetTCHwnd;

  //GetWindowInfo(MainT,wi);
  {*********}
  siz:=Height;
  //((wi.rcWindow.Bottom-wi.rcWindow.Top))div 2; // 

  {       }
 if not IsPanBoTop then
  begin
   //Left panel
   th:=GetMyPanel(mainT,TCWND.MyPLeft);
   GetWindowInfo(th,wi);
   SetWindowPos( th,HWND_BOTTOM ,  0,0,  wi.rcWindow.Right-wi.rcWindow.Left,  siz,SWP_NOMOVE);

   //Right Panel
   th:=GetMyPanel(mainT,TCWND.MyPRight);
   GetWindowInfo(th,wi);
   SetWindowPos( th,HWND_BOTTOM ,  0,0,  wi.rcWindow.Right-wi.rcWindow.Left,  siz,SWP_NOMOVE);

   //Divider
   th:=GetMyPanel(mainT,TCWND.Divider);
   GetWindowInfo(th,wi);
   SetWindowPos( th,HWND_TOP ,  0,0, wi.rcWindow.Right-wi.rcWindow.Left,  siz,SWP_NOMOVE);

    //Lister
   th:=GetMyPanel(mainT,TCWND.Lister);
   GetWindowInfo(th,wi);
   SetWindowPos( th,HWND_TOP ,  0,0, wi.rcWindow.Right-wi.rcWindow.Left,  siz-60,SWP_NOMOVE);

     //Tree
   th:=GetMyPanel(GetTCHWnd,TCWND.MyTree);
   if th>0 then
    begin
       //Left panel
     th1:=GetMyPanel(mainT,TCWND.MyPLeft);
     GetWindowInfo(th1,wi1);
     GetWindowInfo(th,wi);
     siz:=wi1.rcWindow.Bottom-wi.rcWindow.Top;
     SetWindowPos( th,HWND_BOTTOM ,  0,0,  wi.rcWindow.Right-wi.rcWindow.Left, siz,SWP_NOMOVE);
    end;


  end else
   begin
{     x:=1;
     y:=GetXSizeofH(PanTop,GetMyPanel(GetTCHWnd,Divider));
     sendmessage(GetMyPanel(GetTCHWnd,Divider), WM_LBUTTONDOWN, MK_LBUTTON, x + y shl 16);
     y:=siz;
     sendmessage(GetMyPanel(GetTCHWnd,Divider), WM_LBUTTONUP, MK_LBUTTON, x + y shl 16);
   }
   end;

end;
//-----------------------------------------------------------------

//  main  
///-----------------------------------------------------------------
type   TEnumWindowsParam = record
                            dwPID: DWORD;
                            hFoundWnd: HWND;
                           end;
       PEnumWindowsParam = ^TEnumWindowsParam;


function EnumWindowsProc(hWnd: THandle; l: LPARAM): BOOL; stdcall;
var   pParam: PEnumWindowsParam;
      dwPID: DWORD;
      buf: array[0..200] of char;
begin
  pParam:= PEnumWindowsParam(l);
  dwPID:= 0;
  GetWindowThreadProcessId(hWnd, @dwPID);
  if pParam^.dwPID=dwPID then
   if (GetClassName(hWnd, buf, SizeOf(buf))>0) and (buf='TTOTAL_CMD') then
    begin
     pParam^.hFoundWnd:= hWnd;
     Result:= false;
    end;
  Result:= true;
end;

function GetTCHWnd: THandle;
var   param: TEnumWindowsParam;
begin
  param.dwPID:= GetCurrentProcessId;
  param.hFoundWnd:= 0;
  EnumWindows(@EnumWindowsProc, LPARAM(@param));
  if IsWindow(param.hFoundWnd) then
   Result:= param.hFoundWnd    else
   Result:= 0;
end;
///-----------------------------------------------------------------

//  (   )
///-----------------------------------------------------------------
procedure RereadPanel(hWnd: THandle);
const
  EM_DISPLAYBAND = WM_USER+51;
  cm_RereadSource = 540;
begin
//Sleep(50);
  PostMessage(hWnd, WM_SIZE, 0, 0);     // Better than re-read, doesn't cause crash on exit!
//Sleep(50);
end;
///-----------------------------------------------------------------

function PanelWithCommandLine(Hands:TStringList):integer;
var i,miny:integer;
    r:trect;
begin
  result:=-1;
  i:=0;
  miny:=-10000;
  while i<Hands.Count do begin   // find bottom window = cmd line window
    GetWindowRect(HWND(Hands.Objects[i]),r);
    if r.top>miny then begin
      result:=i;
      miny:=r.top;
    end;
    i:=i+1
  end;
end;

//  
///-----------------------------------------------------------------
Function GetMyPanel(MainTCWnd:THandle; What:TMyPanelType):THandle;
var MyLbs,Hands,Divs:TStringList;
    dvp,DvTL,DvB,DvTR,MyL,MYH:THandle;
   x, min,i:integer;
    wi0,wi1,wi2:tagWINDOWINFO;
begin

{ TODO :  .  what       }

 try
  //TMyPanels
  ///---------------
  Hands:=TStringList.Create;

    MYH:=MyFindWindowEx(MainTCWnd,0,'TMyPanel',nil);

    While Myh<>0 do
     begin
      Hands.AddObject(IntToStr(Myh),TObject(MYH));
      MYH:=MyFindWindowEx(MainTCWnd,MYH,'TMyPanel',nil);
     end;
  ///---------------

  //TMyListboxes
  ///---------------
  {  a  }
  MyLbs:=TStringList.Create;
  MyL:=MyFindWindowEx(MainTCWnd,0,'TMyListBox',nil);

    While MyL<>0 do
     begin
      MyLbs.AddObject(IntToStr(MyL),TObject(MYL));
      MYL:=MyFindWindowEx(MainTCWnd,MYL,'TMyListBox',nil);
     end;
  ///---------------

    //TPanels
  ///---------------
  Divs:=TStringList.Create;
if What in [TreeLeftDiv,TreeRightDiv,Divider] then
 begin


  Dvp:=MyFindWindowEx(MainTCWnd,0,'TPanel',nil);

    While Dvp<>0 do
     begin
      Divs.AddObject(IntToStr(Dvp),TObject(Dvp));
      Dvp:=MyFindWindowEx(MainTCWnd,Dvp,'TPanel',nil);
     end;

   {       (DvTL,DvB,DvTR)}
    x:=Divs.Count;
    case x of
    1: DvB:=MyFindWindowEx(MainTCWnd,0,'TPanel',nil);
    2:
       begin
        if not windows.GetWindowInfo(Integer(divs.Objects[0]),wi0) then
          begin
            result:=0;
            exit;
          end;

        if not windows.GetWindowInfo(Integer(divs.Objects[1]),wi1) then
          begin
            result:=0;
            exit;
          end;

           if not IsPanBoTop then
             begin
              DvTL:=IfThen(wi0.rcWindow.Left<wi1.rcWindow.Left,Integer(divs.Objects[0]),Integer(divs.Objects[1]));
              Divs.Delete(Divs.IndexOf(IntToStr(DvTL)));
              DvB:=Integer(divs.Objects[0]);
             end
           else
             begin
              DvTL:=IfThen(wi0.rcWindow.Top<wi1.rcWindow.Top,Integer(divs.Objects[0]),Integer(divs.Objects[1]));
              Divs.Delete(Divs.IndexOf(IntToStr(DvTL)));
              DvB:=Integer(divs.Objects[0]);
             end;

       end;
  3:
         begin

           if not windows.GetWindowInfo(Integer(divs.Objects[0]),wi0) then
              begin
                result:=0;
               exit;
              end;

           if not windows.GetWindowInfo(Integer(divs.Objects[1]),wi1) then
             begin
                result:=0;
               exit;
             end;

            if not windows.GetWindowInfo(Integer(divs.Objects[2]),wi2) then
              begin
                result:=0;
                exit;
              end;

          if not IsPanBoTop then
           begin

            DvTL:=IfThen(wi0.rcWindow.Left<wi1.rcWindow.Left,Integer(divs.Objects[0]),Integer(divs.Objects[1]));
            DvTL:=IfThen(wi1.rcWindow.Left<wi2.rcWindow.Left,Integer(divs.Objects[1]),Integer(divs.Objects[2]));
            Divs.Delete(Divs.IndexOf(IntToStr(DvTL)));
            windows.GetWindowInfo(Integer(divs.Objects[0]),wi0);
            windows.GetWindowInfo(Integer(divs.Objects[1]),wi1);
            DvB:=IfThen(wi0.rcWindow.Left<wi1.rcWindow.Left,Integer(divs.Objects[0]),Integer(divs.Objects[1]));
            Divs.Delete(Divs.IndexOf(IntToStr(DvB)));
            DvTR:=Integer(divs.Objects[0]);
           end
          else
           begin
            DvTL:=IfThen(wi0.rcWindow.Top<wi1.rcWindow.Top,Integer(divs.Objects[0]),Integer(divs.Objects[1]));
            DvTL:=IfThen(wi1.rcWindow.Top<wi2.rcWindow.Top,Integer(divs.Objects[1]),Integer(divs.Objects[2]));
            Divs.Delete(Divs.IndexOf(IntToStr(DvTL)));
            windows.GetWindowInfo(Integer(divs.Objects[0]),wi0);
            windows.GetWindowInfo(Integer(divs.Objects[1]),wi1);
            DvB:=IfThen(wi0.rcWindow.Top<wi1.rcWindow.Top,Integer(divs.Objects[0]),Integer(divs.Objects[1]));
            Divs.Delete(Divs.IndexOf(IntToStr(DvB)));
            DvTR:=Integer(divs.Objects[0]);
           end;

         end;
    end;
  end;  
  ///---------------


  case What of

     Cmd: begin
            i:=PanelWithCommandLine(Hands);
            if i>=0 then
              result:=Integer(Hands.Objects[i]);
          end;
     CmdEdit:begin
                i:=PanelWithCommandLine(Hands);
                if i>=0 then begin
                  Myh:=MyFindWindowEx(Integer(Hands.Objects[i]),0,'TMyComboBox',nil);
                  if Myh<>0 then
                   begin
                    result:=MyFindWindowEx(Myh,0,'Edit',nil);
                   end;
                 end;
             end;
     TreeLeftDiv: result:=DvTL;

     TreeRightDiv: result:=DvTR;

     Divider: result:=DvB;

     ButtonBar: begin
                 result:=MyFindWindowEx(MainTCWnd,0,'TButtonBar',nil);
                end;
     Lister: begin
               result:=MyFindWindowEx(MainTCWnd,0,'TLister',nil);
             end;

     MyTree:begin //        
              if (MyLbs.Count=4) or (MyLbs.Count=2) then begin
                                     result:=0;
                                     Exit;
                                    end;
              MyL:=Integer(MyLbs.Objects[0]);
              windows.GetWindowInfo(Integer(MyLbs.Objects[0]),wi0);
              min:=wi0.rcWindow.Top;
              for i:=1 to MyLbs.Count-1 do
               begin
                windows.GetWindowInfo(Integer(MyLbs.Objects[i]),wi1);
                if wi1.rcWindow.Top<min then
                 begin
                  MyL:=Integer(MyLbs.Objects[i]);
                  min:=wi1.rcWindow.Top;
                 end;

               end;
              Result:=MyL;
            end;

  else

           begin//-------------------------------------------------------------
                //  ,  2 -   
                  i:=PanelWithCommandLine(Hands);
                  if i<>-1 then Hands.Delete(i);
                  for i:=Hands.count-1 downto 0 do begin
                    Myh:=MyFindWindowEx(Integer(Hands.Objects[i]),0,'TMyComboBox',nil);
                    if Myh=0 then
                      Hands.Delete(i);
                  end;

                  if not windows.GetWindowInfo(Integer(Hands.Objects[0]),wi0) then begin result:=0; exit; end;
                  if not windows.GetWindowInfo(Integer(Hands.Objects[1]),wi1) then begin result:=0; exit; end;

                   if wi0.rcWindow.Left<>wi1.rcWindow.Left then
                                     //    
                                     begin //---------------------------------
                                             if wi0.rcWindow.Left<wi1.rcWindow.Left then
                                              begin
                                              if What=MyPLeft then
                                                            result:=Integer(Hands.Objects[0])
                                                           else
                                                            result:=Integer(Hands.Objects[1]);
                                              // if assigned(Hands) then Hands.Free;
                                              // exit;
                                              end
                                             else
                                              begin
                                               if What=MyPLeft then
                                                            result:=Integer(Hands.Objects[1])
                                                           else
                                                            result:=Integer(Hands.Objects[0]);
                                              // if assigned(Hands) then Hands.Free;
                                              // exit;
                                              end;

                                     end  //---------------------------------
                              else
                                     //    
                                     begin //---------------------------------
                                             if wi0.rcWindow.Top<wi1.rcWindow.Top then
                                              begin
                                               if What=MyPLeft then
                                                            result:=Integer(Hands.Objects[0])
                                                           else
                                                            result:=Integer(Hands.Objects[1]);
                                              // if assigned(Hands) then Hands.Free;
                                              // exit;
                                              end
                                             else
                                              begin
                                               if What=MyPLeft then
                                                            result:=Integer(Hands.Objects[1])
                                                           else
                                                            result:=Integer(Hands.Objects[0]);
                                           //    if assigned(Hands) then Hands.Free;
                                            //   exit;
                                              end;

                                     end;  //---------------------------------


          end;//-----------------------------------------------------------------


  end;

 finally
  if assigned(Hands) then Hands.Free;
  if assigned(MyLbs) then MyLbs.Free;
  if assigned(Divs) then Divs.Free;
 end;

end;
///-----------------------------------------------------------------

//Caption   cmd panel
///-----------------------------------------------------------------
Function GetTCMyPcmdWnd(MainWnd:THandle;var WndText:String;var wnd:THandle):boolean;
var Main,Sec,kon:THandle;  nm:Pchar;
begin
result:=false;
Main:=MainWnd;
Sec:=MyFindWindowEx(Main,0,'TMyPanel',nil);
kon:=0;
While (sec<>0) and (kon=0) do
  begin
   kon:=MyFindWindowEx(sec,0,'TMyPanel',nil);
   Sec:=MyFindWindowEx(Main,sec,'TMyPanel',nil);
  end;
if kon=0 then exit
         else result:=true;

wnd:=kon;
getmem(nm,MAX_PATH);
windows.GetWindowText(kon,nm,MAX_PATH);
WndText:=nm;
freemem(nm);
end;
///-----------------------------------------------------------------

// TMypanels-  MainWnd
///-----------------------------------------------------------------
Function GetTCMyPWnd(MainWnd:THandle;WndList:TStrings; wndTabs:TStrings):boolean;
var Main,Sec,tab,kon:THandle;  nm:Pchar;
begin
result:=false;
Main:=MainWnd;
Sec:=MyFindWindowEx(Main,0,'TMyPanel',nil);
kon:=0;


While (sec<>0) do
  begin
   tab:=MyFindWindowEx(sec,0,'TMyTabControl','');
    While (tab<>0) do
     begin
      kon:=MyFindWindowEx(tab,kon,'TMyPanel',nil);
      While kon<>0 do
       begin
        if kon<>0 then
         begin
          getmem(nm,255);
          windows.GetWindowText(kon,nm,255);
          WndList.AddObject(String(nm),TObject(kon));
          freemem(nm);
          result:=true;
         end;
        kon:=MyFindWindowEx(tab,kon,'TMyPanel',nil);
       end;
      wndTabs.InsertObject(0,IntToStr(tab),TObject(tab));
      tab:=MyFindWindowEx(sec,tab,'TMyTabControl','');
     end;
   Sec:=MyFindWindowEx(Main,sec,'TMyPanel',nil);
  end;
end;
///-----------------------------------------------------------------

// My
///-----------------------------------------------------------------
Function GetTCMyLbWnd(MainWnd:THandle; var WLeft,WRight:THandle):boolean;
var fir,Sec:THandle; wi0,wi1:tagWINDOWINFO;
begin
 result:=false;

  Fir:=MyFindWindowEx(MainWnd,0,'TMyListBox',nil);
  Sec:=MyFindWindowEx(MainWnd,fir,'TMyListBox',nil);

  GetWindowInfo(Fir,wi0);
  GetWindowInfo(Sec,wi1);
  if wi0.rcWindow.Left<>wi1.rcWindow.Left then

          //    
          begin //---------------------------------
                  if wi0.rcWindow.Left<wi1.rcWindow.Left then
                   begin
                    WLeft:=Fir;
                    WRight:=sec;
                   end
                  else
                   begin
                    WLeft:=Sec;
                    WRight:=Fir;
                   end;


          end  //---------------------------------
   else
          //    
          begin //---------------------------------
                  if wi0.rcWindow.Top<wi1.rcWindow.Top then
                   begin
                    WLeft:=Fir;
                    WRight:=sec;
                   end
                  else
                   begin
                    WLeft:=Sec;
                    WRight:=Fir;
                   end;

          end;  //---------------------------------



 result:=true;
end;
///-----------------------------------------------------------------

//   mainWindow 
///-----------------------------------------------------------------
Function GetTCWnd(WndList:TStrings):boolean;
var Main:THandle;
begin
 result:=false;
 Main:=FindWindow('TTOTAL_CMD',nil);
  if main=0 then exit;
 while Main<>0 do
  begin
   WndList.AddObject(inttostr(Main),TObject(Main));
   Main:=MyFindWindowEx(0,Main,'TTOTAL_CMD',nil);
  end;
 result:=true;
end;
///-----------------------------------------------------------------

//  EXE (GUI,CUI(Console),Native,Unknown )
///-----------------------------------------------------------------
function GetSubSystem(Filename:Pchar):Pchar;
type
   PIMAGE_DOS_HEADER=^IMAGE_DOS_HEADER;
type
   PIMAGE_NT_HEADERS=^IMAGE_NT_HEADERS;
type
   PIMAGE_SECTION_HEADER=^IMAGE_SECTION_HEADER;

var
        DosHead:IMAGE_DOS_HEADER;
        imgsection:IMAGE_SECTION_HEADER;
        i:integer;
        dop:cardinal;
        numbers:word;
        buf,EPSection:array[0..512] of char;
        EntryPoint,FileOffset:integer;
        FirstBytes:array[1..4] of char;
        hFile,hFileMapping:cardinal;
        p,a:PBYTE;
        bytesread:dword;
        hImg:DWORD;
        pc:pchar;
        PEHead:IMAGE_NT_HEADERS;
begin
//if CheckOthers then Application.Terminate;


  try
   hFile:=CreateFile(pchar(filename),GENERIC_READ or GENERIC_WRITE, FILE_SHARE_READ or FILE_SHARE_WRITE,nil,OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL,0);
  except
   MessageBox(0,'','',0);
  end;

  if (hFile<>INVALID_HANDLE_VALUE) then
	begin
   hFileMapping:=CreateFileMapping(hFile, nil, PAGE_READWRITE, 0, 0, 'mappedfile');
   if hFileMapping<>0 then
		begin
      p:=MapViewOfFile(hFileMapping,FILE_MAP_READ,0,0,0);
      a:=p;
      doshead:=PIMAGE_DOS_HEADER(p)^;
      if p<> nil then
       	if doshead.e_magic=IMAGE_DOS_SIGNATURE then
						begin
                                                        p:=pointer(integer(p)+doshead._lfanew);
                         pehead:=PIMAGE_NT_HEADERS(p)^;
                         if pehead.Signature=IMAGE_NT_SIGNATURE then
                                 begin
                                         case pehead.OptionalHeader.Subsystem of
                                                 0: result:='Unknown';
                                                 1: result:='Native';
                                                 2: result:='GUI';
                                                 3: result:='CUI';
                                         else result:='Unknown';
                                         end;
                                  end;
            end;
  end;
end;
  UnMapViewOfFile(a);
  CloseHandle(hFileMapping);
  CloseHandle(hFile);

end;
///-----------------------------------------------------------------

end.